var App = function () {
    return {
        init: function () {
            $(".cl-vnavigation li ul").each(function () {
                $(this).parent().addClass("parent");
            });

            $(".cl-vnavigation li ul li.active").each(function () {
                $(this).parent().show().parent().addClass("open");
            });

            if ($("#cl-wrapper").hasClass("fixed-menu")) {
                var scroll = $("#cl-wrapper .menu-space");
                scroll.addClass("nano nscroller");

                function update_height() {
                    var button = $("#cl-wrapper .collapse-button");
                    var collapseH = button.outerHeight();
                    var navH = $("#head-nav").height();
                    var height = $(window).height() - ((button.is(":visible")) ? collapseH : 0) - navH;
                    scroll.css("height", height);
                    $("#cl-wrapper .nscroller").nanoScroller({ preventPageScrolling: true });
                }

                $(window).resize(function () {
                    update_height();
                });

                update_height();
                $("#cl-wrapper .nscroller").nanoScroller({ preventPageScrolling: true });

            }

            $(".cl-vnavigation").delegate(".parent > a", "click", function (e) {
                $(".cl-vnavigation .parent.open > ul").not($(this).parent().find("ul")).slideUp(300, 'swing', function () {
                    $(this).parent().removeClass("open");
                });

                var ul = $(this).parent().find("ul");
                ul.slideToggle(300, 'swing', function () {
                    var p = $(this).parent();
                    if (p.hasClass("open")) {
                        p.removeClass("open");
                    } else {
                        p.addClass("open");
                    }
                    $("#cl-wrapper .nscroller").nanoScroller({ preventPageScrolling: true });
                });
                e.preventDefault();
            });
        }
    };
}();

$(document).ready(function () {
    $("body").css({opacity: 1, 'margin-left': 0});
    App.init();

    var current_url = location.protocol + "//" + location.hostname + ":" + location.port;
    $("#test_url").attr("placeholder", current_url);
});

$("#test_list a.nav_url_a").click(function () {
    var $this = $(this);
    var url = $this.attr('href');
    var request_method = $this.nextAll(".method").text().toUpperCase();

    $("#test_header").text($this.text() + " - " + request_method);
    $("#test_path").val(url);

    var params = $this.nextAll(".params").text();
    $("#params_desc").text(params);
    $("#response_desc").text($this.nextAll(".return").text());

    params = params.split(',')
    for (var i = 0; i < params.length; i++) {
        params[i] = $.trim(params[i])
    }

    $("#params_details").attr("rows", params.length);
    $("#params_details").val(params.join(': \n') + ': ');
    $("#response_details").html('无');
    $("#request_method").val(request_method);

    $this.parent().siblings().removeClass("active");
    $this.parent().addClass("active")
    return false
});

function dump(arr, level) {
    var dumped_text = "";
    if (!level) level = 0;

    var level_padding = 0;
    for (var j = 0; j < level + 1; j++) level_padding += 1;

    if (typeof(arr) == 'object') {
        for (var item in arr) {
            var value = arr[item];
            if (typeof(value) == 'object') {
                dumped_text += nbsp(level_padding) + '"' + item + '" => {<br/>';
                dumped_text += dump(value, level + 1);
            } else {
                dumped_text += nbsp(level_padding) + '"' + item + '" => "' + value + '",<br/>';
            }
        }
        dumped_text += nbsp(level_padding - 1) + '},<br/>';
    } else {
        dumped_text = "===>" + arr + "<===(" + typeof(arr) + ")";
    }
    return dumped_text;
}

function json(str) {
    return "{<br/>" + dump(str)
}

function nbsp(count) {
    var s = ""
    for (var i = 0; i < count; i++) {
        s += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
    }
    ;
    return s
}

$("#go").click(function () {
    var old_str = $("#params_details").val();
    var result_str = "";

    if ((old_str != "") && (old_str != "无: ")) {
        var str_arr = old_str.split("\n");

        var new_str = [];
        for (var i = 0; i < str_arr.length; i++) {
            var tmp_arr = str_arr[i].split(":")
            new_str.push('"' + $.trim(tmp_arr[0]) + '":"' + $.trim(tmp_arr[1]) + '"');
        }

        result_str = new_str.join(",");
    }

    var target_url = $("#test_url").val();
    if (target_url == "") {
        target_url = $("#test_url").attr('placeholder');
    }
    target_url += $("#test_path").val();
    var data_str = '{' + result_str + ',"url":"' + target_url +'"' + 
        ',"method":"'+ $("#request_method").val() + '"}'
    var str_json = jQuery.parseJSON(data_str);

    $.ajax({
        url: "/post",
        data: str_json,
        type: "post",
        async: false,
        success: function (data) {
            $("#response_details").html(json(data))
        }
    });
});